Subject: [RTG-DIR] Referencing material behind a paywall

From: "Adrian Farrel" <[email-masked]>
Date: Fri, 7 Dec 2018 21:20:47 -0000

Hi,

[Changed the subject line, tried to reduce the recipients (but it's still a bit much), added the RSE in case she has advice]

It's tricky. Sometimes we need to reference material that is behind a paywall or simply in a paper journal. Sometimes we need to reference something from a published book.

Most often such references are Informative, and that's usually considered OK so long as there is a stable reference to the material (such as a URL, or an ISBN, or a DOI). 

For Normative references the issue is more complex because the implication is that the reference must be read in order to understand and implement the RFC. That, of course, is a problem for an open access organisation like the IETF (you could look at https://open-stand.org/ for an overview of the principles that underlie this).

In general (and I think your draft is an example of this) it is possible to describe/rewrite the pieces of normative text without infringing copyright. That usually reduces the reference to Informative and provides enough information in the RFC for implementation. Your draft is an example of this because you have described the algorithms in your text with enough detail to allow an implementation: the reference is really only there to provide context and proof of the algorithms. (And anyway, having found a freely accessible copy of the reference in your draft, we are probably home and dry.)

Cheers,
Adrian

-----Original Message-----
From: Satya Mohanty (satyamoh) <[email-masked]> 
Sent: 07 December 2018 17:12
To: Adrian Farrel <[email-masked]>; [email-masked]
Cc: [email-masked]; [email-masked]; [email-masked]
Subject: Re: Rtgdir last call review of draft-ietf-bess-evpn-df-election-framework-06

Hi Adrian,

Thank you very much for your detailed review and comments.
We will take care of all the nits that you have pointed out and include the reference to the IEEE/ACM TON paper (the link you have pointed out is indeed correct).

However, I had one query. Most of the time research journal/conference papers will be behind a paywall and there may not be a free cached copy available online.
How do we get across this problem?

Best,
--Satya

On 12/7/18, 7:20 AM, "Adrian Farrel" <[email-masked]> wrote:

    Reviewer: Adrian Farrel
    Review result: Has Nits
    
    Hello,
    I have been selected as the Routing Directorate reviewer for this draft. The
    Routing Directorate seeks to review all routing or routing-related drafts as
    they pass through IETF last call and IESG review, and sometimes on special
    request. The purpose of the review is to provide assistance to the Routing ADs.
    For more information about the Routing Directorate, please see
    ?http://trac.tools.ietf.org/area/rtg/trac/wiki/RtgDir Although these comments
    are primarily for the use of the Routing ADs, it would be helpful if you could
    consider them along with any other IETF Last Call comments that you receive,
    and strive to resolve them through discussion or by updating the draft.
    
    Document: draft-ietf-bess-evpn-df-election-framework-06.txt
    Reviewer: Adrian Farrel
    Review Date: 2018-12-07
    IETF LC End Date: 2018-12-18
    Intended Status: Standards Track
    
    Summary:
    
    This document is basically ready for publication, but has nits that should be
    considered prior to publication.
    
    Comments:
    
    This document addresses issues in the default election algorithm used for
    Designated Forwarder Election in EVPN (RFC 7432 and RFC 8124) by defining a new
    election algorithm and a capability to influence the election result for a
    VLAN, depending on the state of the associated Attachment Circuit.
    
    This is an exceptionally clear and well written document. The authors and the
    working group are to be congratulated.
    
    During my review I observed a number of small issues and editorial nits. I
    don't believe any of these is cause for discussion in the working group, but it
    would be sensible to resolve them before publication.
    
    Thanks and Happy Christmas,
    Adrian
    --
    It's Christmas.
    Buy someone you love a book of fairy tales.
    https://www.feedaread.com/profiles/8604/
    Available from your favourite online bookseller.
    Or contact me to receive a signed copy by mail.
    
    ===
    
    Major Issues:
     No major issues found
    
    ===
    
    Minor Issues:
    
    HRW1999 is provided as a normative reference, and from the text I can
    see why. But no URL (stable or otherwise) is given for the reference.
    Using my favorite search engine, I looked for and found a copy of
    the referenced document on the IEEE site behind a paywall. I don't
    think that will do at all. However, there is a version at
    https://www.microsoft.com/en-us/research/wp-content/uploads/2017/02/HRW98.pdf
    That appears to be dated 1998, but otherwise could be the same paper.
    
    ---
    
    When I read in Section 3...
    
       In addition, since the specification in EVPN
       [RFC7432] does leave several questions open as to the precise final
       state machine behavior of the DF election, section 3.1 describes
       precisely the intended behavior.
    
    ... I wondered whether this document is updating 7432 in that respect.
    
    Other features later in the document (such as section 5) confirm this.
    
    ---
    
    Notwithstanding the mention of backward compatiblity in section 6, I
    think it would be a good idea to include a very short section 3.2.1.
    
    3.2.1.  Backward Compatibility
    
       Legacy implementations (i.e., those that predate this specification)
       will not advertise the DF Election Extended Community.  That means
       that all other participating PEs will not receive DF preferences and
       will revert to the defailt algorithm without AC-Influenced DF
       Election.
    
       Similarly, a legacy implementation receiving a DF Election Extended
       Community will ignore it and will continue to use the default
       algorithm.
    
    ---
    
    On first reading, I missed an important subtlty in 3.2. The paragraph...
    
         - Otherwise if even a single advertisement for the type-4 route is
           not received with the locally configured DF Alg and capability,
           the default DF Election algorithm (modulus) algorithm MUST be
           used as in [RFC7432].
    
    ...is really important because it handles what to do if different
    participating PEs disagree about which algorithm to use.  Your text is
    perfectly fine and adequate, but the "locally configured" sort of hid
    it from me first time around.
    
    Maybe add a sentence to the end of the bullet point to say...
    
    "This procedure handles the case where participating PEs disagree about
    the DF algorithm and capability to apply."
    
    ---
    
    Section 4 introduces 8124 for the first time. It's good that this is
    applicable to private wire EVPN as well as 7432 EVPN. Maybe bring this
    into focus in the Introducion?
    
    It does make me wonder whether you are also updating 8124.
    
    ---
    
    I think section 7 is good. Since you note that the "unfair" situation
    may be created maliciously, should you note that there is also scope for
    a downgrade attach where the advertisement from one PE is hidden, the
    preferred algorithm is modified to any unexpected value, or any
    unexpected bit in the capabilities bitfield is set? I think such an
    attack assumes either a subversion of the PE (perhaps via its
    configuration) or modification of the BGP message. Thus, it is not a
    probable if adequate existing security mechanisms are used.
    
    ===
    
    Nits:
    
    The RFC Editor will require that the first section in the document is
    the Introduction.
    
    ---
    
    You use VNI and I-SID without expansion.
    
    ---
    
    2.1
    s/proposes/defines/
    
    ---
    
    2.3
    s/procedure Generally,/procedure.  Generally,/
    
    ---
    
    3.2 has
    
       For the DF election procedures to be consistent and unanimous, it is
       necessary that all the participating PEs agree on the DF Election
       algorithm and capabilities to be used.
    
    This is exactly the type of statement I was hoping for when I opened the
    document, so thanks. But... :-)
    
    This depends slightly on the definition of "all participating PEs". You
    don't need all PEs in the EVPN to use the same algorithm, only the PEs
    that share multi-homing connections.
    
    You also use the term in 2.1 and other places in the document, so
    perhaps I am worrying too much.
    
    ---
    
    4.
    s/the state of the server states/the server states./
    s/on Unix utilities rand and srand/on the Unix utilities rand and srand/
    
    ---
    
    I am not sure why you describe Wrand2 in section 4.2 because you
    immediately decide to not use it. Maybe you can just describe Wrand and
    observe that does the job?
    
    ---
    
    4.2
       s/HRW solves the disadvantage/HRW solves the disadvantages/

---

From: Heather Flanagan <[email-masked]>
Date: Mon, 10 Dec 2018 12:41:49 -0800

> In general (and I think your draft is an example of this) it is possible to describe/rewrite the pieces of normative text without infringing copyright. That usually reduces the reference to Informa…

Hello all,

In general, I think having an open standard normatively reference 
paywalled material is a terrible idea. That said, at the IESG meeting in 
Bangkok, we discussed this a bit. Ekr offered an interesting proposal 
that would have this kind of reference be treated in a fashion similar 
to IPR declarations. I am waiting to see a more concrete proposal along 
these lines--and discuss it with the other streams to see if it can 
apply to all--before I put anything in a future style guide.

-Heather

---

From: Carsten Bormann <[email-masked]>
Date: Mon, 10 Dec 2018 23:08:35 +0100

On Dec 10, 2018, at 21:41, Heather Flanagan <[email-masked]> wrote:
> 
> similar to IPR declarations

For those people who believe in “IPR”, copyrights (which is the mechanism used to protect specifications that are behind paywalls) are “IPR".  So this is very logical, even if the impact of this kind of IPR on large-scale vendors is much more limited than the kinds of “IPR” we usually talk about in the IETF (i.e., patent claims).  The impact on people who need to configure, diagnose, research, or otherwise assess the technology is still very relevant.

Grüße, Carsten

---

From: Stephen Farrell <[email-masked]>
Date: Mon, 10 Dec 2018 22:14:32 +0000

On 10/12/2018 20:41, Heather Flanagan wrote:
> Ekr offered an interesting proposal that would have this kind of
> reference be treated in a fashion similar to IPR declarations.

Not a bad idea. I'd also make it like the downref registry [1]
though, since once we've got a normative reference in one RFC
to e.g. some IEEE 802 thing, then it shouldn't need new process
to have a 2nd RFC do the same.

Cheers,
S.

[1] https://datatracker.ietf.org/doc/downref/

---

From: "Satya Mohanty (satyamoh)" <[email-masked]>
Date: Wed, 19 Dec 2018 17:16:00 +0000

Thank you Stephen, Carsten and Heather for your input.
Jorge will be publishing the revised version soon.

Best Regards,
--Satya

On 12/10/18, 2:14 PM, "Stephen Farrell" <[email-masked]> wrote:

    
    
    Cheers,
    S.